commit da8de4ba30871354060bbfc142f32ce0062a6698
Author: Michael Moll <kvedulv@kvedulv.de>
Date:   Mon Jul 9 14:28:39 2018 +0200

    support Ubuntu/bionic (#437)

diff --git a/.travis.yml b/.travis.yml
index 13f7498..a831c2d 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -3,7 +3,6 @@
 #   https://github.com/theforeman/foreman-installer-modulesync
 rvm:
   - 2.1.9
-  - 2.2.6
   - 2.3.0
   - 2.4.1
 env:
@@ -16,6 +15,8 @@ matrix:
   include:
     - rvm: 2.4.1
       env: PUPPET_VERSION=5.0
+    - rvm: 2.5.1
+      env: PUPPET_VERSION=5.0
     # Acceptance tests
     - rvm: 2.3.1
       dist: trusty
diff --git a/manifests/params.pp b/manifests/params.pp
index 33f1c6f..f7e4d75 100644
--- a/manifests/params.pp
+++ b/manifests/params.pp
@@ -58,26 +58,16 @@ class foreman_proxy::params {
       } else {
         $tftp_root = '/srv/tftp'
       }
-      if $::operatingsystem == 'Ubuntu' and $::operatingsystemrelease == '14.04' {
-        $tftp_syslinux_filenames = [
-          '/usr/lib/syslinux/chain.c32',
-          '/usr/lib/syslinux/mboot.c32',
-          '/usr/lib/syslinux/menu.c32',
-          '/usr/lib/syslinux/memdisk',
-          '/usr/lib/syslinux/pxelinux.0',
-        ]
-      } else {
-        $tftp_syslinux_filenames = [
-          '/usr/lib/PXELINUX/pxelinux.0',
-          '/usr/lib/syslinux/memdisk',
-          '/usr/lib/syslinux/modules/bios/chain.c32',
-          '/usr/lib/syslinux/modules/bios/ldlinux.c32',
-          '/usr/lib/syslinux/modules/bios/libcom32.c32',
-          '/usr/lib/syslinux/modules/bios/libutil.c32',
-          '/usr/lib/syslinux/modules/bios/mboot.c32',
-          '/usr/lib/syslinux/modules/bios/menu.c32',
-        ]
-      }
+      $tftp_syslinux_filenames = [
+        '/usr/lib/PXELINUX/pxelinux.0',
+        '/usr/lib/syslinux/memdisk',
+        '/usr/lib/syslinux/modules/bios/chain.c32',
+        '/usr/lib/syslinux/modules/bios/ldlinux.c32',
+        '/usr/lib/syslinux/modules/bios/libcom32.c32',
+        '/usr/lib/syslinux/modules/bios/libutil.c32',
+        '/usr/lib/syslinux/modules/bios/mboot.c32',
+        '/usr/lib/syslinux/modules/bios/menu.c32',
+      ]
     }
     /^(FreeBSD|DragonFly)$/: {
       # if set to true, no repo will be added by this module, letting you to
diff --git a/metadata.json b/metadata.json
index b702179..416175c 100644
--- a/metadata.json
+++ b/metadata.json
@@ -86,7 +86,8 @@
     {
       "operatingsystem": "Ubuntu",
       "operatingsystemrelease": [
-        "16.04"
+        "16.04",
+        "18.04"
       ]
     },
     {
diff --git a/spec/classes/foreman_proxy__tftp_spec.rb b/spec/classes/foreman_proxy__tftp_spec.rb
index e05caf4..40d94f4 100644
--- a/spec/classes/foreman_proxy__tftp_spec.rb
+++ b/spec/classes/foreman_proxy__tftp_spec.rb
@@ -40,26 +40,16 @@ describe 'foreman_proxy::tftp' do
         }
       when 'Debian'
         tftp_root = facts[:operatingsystem] == 'Ubuntu' ?  '/var/lib/tftpboot' : '/srv/tftp'
-        if facts[:operatingsystem] == 'Ubuntu' && facts[:operatingsystemrelease] == '14.04'
-          names = {
-            '/usr/lib/syslinux/chain.c32'  => "#{tftp_root}/chain.c32",
-            '/usr/lib/syslinux/mboot.c32'  => "#{tftp_root}/mboot.c32",
-            '/usr/lib/syslinux/menu.c32'   => "#{tftp_root}/menu.c32",
-            '/usr/lib/syslinux/memdisk'    => "#{tftp_root}/memdisk",
-            '/usr/lib/syslinux/pxelinux.0' => "#{tftp_root}/pxelinux.0",
-          }
-        else
-          names = {
-            '/usr/lib/PXELINUX/pxelinux.0'                => "#{tftp_root}/pxelinux.0",
-            '/usr/lib/syslinux/memdisk'                   => "#{tftp_root}/memdisk",
-            '/usr/lib/syslinux/modules/bios/chain.c32'    => "#{tftp_root}/chain.c32",
-            '/usr/lib/syslinux/modules/bios/ldlinux.c32'  => "#{tftp_root}/ldlinux.c32",
-            '/usr/lib/syslinux/modules/bios/libcom32.c32' => "#{tftp_root}/libcom32.c32",
-            '/usr/lib/syslinux/modules/bios/libutil.c32'  => "#{tftp_root}/libutil.c32",
-            '/usr/lib/syslinux/modules/bios/mboot.c32'    => "#{tftp_root}/mboot.c32",
-            '/usr/lib/syslinux/modules/bios/menu.c32'     => "#{tftp_root}/menu.c32",
-          }
-        end
+        names = {
+          '/usr/lib/PXELINUX/pxelinux.0'                => "#{tftp_root}/pxelinux.0",
+          '/usr/lib/syslinux/memdisk'                   => "#{tftp_root}/memdisk",
+          '/usr/lib/syslinux/modules/bios/chain.c32'    => "#{tftp_root}/chain.c32",
+          '/usr/lib/syslinux/modules/bios/ldlinux.c32'  => "#{tftp_root}/ldlinux.c32",
+          '/usr/lib/syslinux/modules/bios/libcom32.c32' => "#{tftp_root}/libcom32.c32",
+          '/usr/lib/syslinux/modules/bios/libutil.c32'  => "#{tftp_root}/libutil.c32",
+          '/usr/lib/syslinux/modules/bios/mboot.c32'    => "#{tftp_root}/mboot.c32",
+          '/usr/lib/syslinux/modules/bios/menu.c32'     => "#{tftp_root}/menu.c32",
+        }
       when 'FreeBSD', 'DragonFly'
         tftp_root = '/tftpboot'
         names = {